/*!
 * \file OperationStatus.h
 * Define operation status enum
 */

#ifndef __OperationStatus_h
#define __OperationStatus_h

/*!
 * \brief Operation status
 * \details
 * \todo SERVER!!!! - Odkomentovat
 */
typedef enum
{
    /*!
     * \brief No error
     */
	OperationStatus_Ok = 0,
    /*!
     * \brief No such variable
     */
    OperationStatus_NoSuchVariable = 1,
    /*!
     * \brief Write failed
     */
    OperationStatus_WriteFailed = 2,
    /*!
     * \brief Size mismatch
     */
    OperationStatus_SizeMismatch = 3,
    /*!
     * \brief Unspecified
     */
    OperationStatus_Unspecified = 4,
    /*!
     * \brief Denied
     */
    OperationStatus_Denied = 5,
    /*!
     * \brief InvalidState
     */
    OperationStatus_InvalidState = 6,
    /*!
     * \brief Failed to load VM image
     */
    OperationStatus_FailedToLoadVmImage = 7,

    /*!
     * \brief Email queue full
     */
    OperationStatus_EmailQueueFull = 8,
    /*!
     * \brief To addr too long
     */
    OperationStatus_ToAddrTooLong = 9,
    /*!
     * \brief From addr too long
     */
    OperationStatus_FromAddrTooLong = 10,
    /*!
     * \brief Subject too long
     */
    OperationStatus_SubjectTooLong = 11,
    /*!
     * \brief Message too long
     */
    OperationStatus_MessageTooLong = 12,
    /*!
     * \brief Server too long
     */
    OperationStatus_ServerTooLong = 13,
    /*!
     * \brief Auth name too long
     */
    OperationStatus_AuthNameTooLong = 14,
    /*!
     * \brief Auth password too long
     */
    OperationStatus_AuthPasswordTooLong = 15,
    /*!
     * \brief Unknown channel
     */
    OperationStatus_UnknownChannel = 16,

    /*!
     * \brief Unknown src encoding
     */
    OperationStatus_UnknownSrcEncoding = 17,
    /*!
     * \brief Unknown dest encoding
     */
    OperationStatus_UnknownDestEncoding = 18,
    /*!
     * \brief Conversion failed
     */
    OperationStatus_ConversionFailed = 19,
    /*!
     * \brief Conversion source illegal
     */
    OperationStatus_ConversionSourceIllegal = 20,
    /*!
     * \brief Conversion source exhausted
     */
    OperationStatus_ConversionSourceExhausted = 21,
    /*!
     * \brief Conversion dest exhausted
     */
    OperationStatus_ConversionDestExhausted = 22,

    /*!
     * \brief Connected
     */
    OperationStatus_Connected = 23,
    /*!
     * \brief Invalid parameter
     */
    OperationStatus_InvalidParameter = 24,
    /*!
     * \brief Not opened
     */
    OperationStatus_NotOpened = 25,
    /*!
     * \brief Timeout
     */
    OperationStatus_Timeout = 26,
    /*!
     * \brief Unknown command
     */
    OperationStatus_UnknownCommand = 27,

    /*!
     * \brief Invalid image version
     */
    OperationStatus_InvalidImageVersion = 28,

    /*!
     * \brief Invalid endian
     */
    OperationStatus_InvalidEndian = 29,
    /*!
     * \brief Image marked as invalid
     */
    OperationStatus_ImageMarkedAsInvalid = 30,
    /*!
     * \brief Empty
     */
    OperationStatus_Empty = 31,

    /*!
     * \brief Overlapp
     */
    OperationStatus_Overlapp = 32,
    /*!
     * \brief Retry
     */
    OperationStatus_Retry = 33,

    /*!
     * \brief Busy
     */
    OperationStatus_Busy = 34,
    /*!
     * \brief Port already used
     */
    OperationStatus_PortAlreadyUsed = 35
} OperationStatus;

#endif
