/*!
 * \file PlatformUtils.h
 *
 * Platform dependent configuration
 * \todo Doplnit !!
 */
#ifndef __PlatformUtils_h
#define __PlatformUtils_h

#define MAX_OS_OBJECT_NAME_LEN 96

#include "./datatypes.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#include <WinSock2.h>
#include <windows.h>
#endif

#if defined(__POSIX__)
#define ULONG		uint32b

#include <string.h>
#include <limits.h>

#if defined(__PIKEOS__)
#include <sys/features.h>
#endif

#endif

#define PLATFORMID_WINDOWS			0x00010000
#define PLATFORMID_LINUX			0x00020000
#define PLATFORMID_UPLC				0x00030000
#define PLATFORMID_PIKEOS			0x00040000
#define PLATFORMID_UNKNOWN			0xffffffff

#define PLATFORMID_UPLC_M007		0x00000001
#define PLATFORMID_UPLC_HT_1		0x00000002

#define PLATFORMID_LINUX_PC			0x00000000
#define PLATFORMID_LINUX_iPLC5xx	0x00000001
#define PLATFORMID_LINUX_MXIO		0x00000002
#define PLATFORMID_LINUX_iPLCP100	0x00000003

extern uint64b CalcFNV1Hash(uint8b *data, uint32b dataLength);

extern void Daemonize(const char *lockFilename, sint32b *lockFile, void (*int_handler)(int));
extern void DaemonizeEnd(const char *lockFilename, sint32b lockFile);

#if defined(_MSC_VER)
	#define SHARK_MAIN_DIR "C:\\RcWareProjects\\SharkWorkDir\\"
	#if !defined(SHARK_LOG_FILE)
		#define SHARK_LOG_FILE SHARK_MAIN_DIR"system.log"
	#endif

	#define PATH_MAX	MAX_PATH
#elif defined(__POSIX__) && !defined(__PIKEOS__)
	#define SHARK_MAIN_DIR "/tftpboot/"
	#if !defined(SHARK_LOG_FILE)
		#define SHARK_LOG_FILE SHARK_MAIN_DIR"system.log"
	#endif
#else
	// nic
#endif

#if defined(_MSC_VER)
	#define NVRAM_NAME SHARK_MAIN_DIR"nvram.bin"
	#define NVRAM_SIZE 0x10000
#elif defined(__POSIX__) && !defined(__PIKEOS__)
	#define NVRAM_NAME "/tftpboot/nvram"
	#define NVRAM_BASE_ADDR		0xfa000000
	#define NVRAM_SIZE			0x00010000
#elif defined(__PIKEOS__)
	#define NVRAM_NAME "/prop/app/hw/nvram/base"
#elif defined(__FREERTOS__)
	#define NVRAM_SIZE (4 * 1024)
#else
	// nic
#endif

#endif



