#include "./SSCPProtocolErrors.h"

const char *GetSscpErrorText(SscpError::SscpError error)
{
	switch(error)
	{
		case SscpError::NoError: return("NoError");

		case SscpError::NoResponse: return("NoResponse");
		case SscpError::FailedToConnect: return("FailedToConnect");
		case SscpError::NotImplemented: return("NotImplemented");
		case SscpError::InvalidFunctionReceived: return("InvalidFunctionRecevied");

		case SscpError::InsufficientRights: return("InsufficientRights");
		case SscpError::UnknownFunction: return("InvalidFunction");
		case SscpError::InvalidVersion: return("InvalidVersion");

		case SscpError::WrongLogin: return("WrongLogin");

		case SscpError::NoSuchFile: return("NoSuchFile");
		case SscpError::NoSuchVariable: return("NoSuchVariable");
		case SscpError::NoSuchTask: return("NoSuchTask");

		case SscpError::WrongOrder: return("WrongOrder");
		case SscpError::WrongParameter: return("WrongParameter");
		case SscpError::InvalidGroupId: return("InvalidGroupId");
		case SscpError::TransmissionInProgress: return("TransmissionInProgress");
		case SscpError::NotRegistered: return("NotRegistered");

		case SscpError::WriteFailed: return("WriteFailed");
		case SscpError::NotAllDataReceived: return("NotAllDataReceived");
		case SscpError::InvalidCrc: return("InvalidCrc");

		case SscpError::DataTooLong: return("DataTooLong");
		case SscpError::TooLongUseFileTransfer: return("TooLongUseFileTransfer");
		case SscpError::FileNameTooLong: return("FileNameTooLong");
		case SscpError::VariableCountLimitExceed: return("VariableCountLimitExceed");
		case SscpError::OutOfBounds: return("OutOfBounds");

		case SscpError::SysCmd_NewImage: return("SysCmd_NewImage");
		case SscpError::SysCmd_InvalidImageArea: return("SysCmd_InvalidImageArea");
		case SscpError::SysCmd_CreateBootImage: return("SysCmd_CreateBootImage");
		case SscpError::SysCmd_WarmReboot: return("SysCmd_WarmReboot");
		case SscpError::SysCmd_ColdReboot: return("SysCmd_ColdReboot");
		case SscpError::SysCmd_StartPlc: return("SysCmd_StartPlc");
		case SscpError::SysCmd_StopPlc: return("SysCmd_StopPlc");
		case SscpError::SysCmd_SetMacAddress: return("SysCmd_SetMacAddress");
		case SscpError::SysCmd_Timeout: return("SysCmd_Timeout");
		case SscpError::SysCmdRequestActive: return("SysCmdRequestActive");
		case SscpError::SysCmdWaitTimeout: return("SysCmdWaitTimeout");

		case SscpError::AlreadyRunning: return("AlreadyRunning");
		case SscpError::AlreadyStopped: return("AlreadyStopped");
		case SscpError::InvalidState: return("InvalidState");

		case SscpError::SizeMismatch: return("SizeMismatch");
		case SscpError::OperationDenied: return("OperationDenied");
		case SscpError::NotLogged: return("NotLogged");

		case SscpError::UnknownChannel: return("UnknownChannel");
		case SscpError::DriverCommandTimeout: return("DriverCommandTimeout");
		case SscpError::UnknownDriverCommand: return("UnknownDriverCommand");

		default: return("<unknown>");
	}
	return ("");
}