#include "./StopWatch.h"
#if !defined(SSCP_STANDALONE_CLIENT)
#include "./EnvironmentData.h"
#endif
#if defined(__OS_X__)
#include <sys/time.h>
#endif


#if defined(_MSC_VER) || defined(__BORLANDC__)
#include <WinSock2.h>
#include <windows.h>
#endif

#if (defined __POSIX__)

#include <time.h>

#define NANOSECONDS_IN_SECOND 1e9

#define GET_TICKS100NS(tmVal) ((uint64b)tmVal.tv_sec * TimeRanges::TicksPerSeconds + (uint64b)tmVal.tv_nsec / 100)
#endif

#if defined(__PIKEOS__)
#include <ddapi/ddapi.h>
#endif

#if defined (__FREERTOS__)
#include "./../../HW/FreeRTOS-ARM/sysutils/time.h"
#endif

StopWatch::StopWatch(void)
{
#if defined(_MSC_VER) || defined(__BORLANDC__)
	m_Frequency = 1;
#endif

	m_StartTime = 0;
}

//-------------------------------------------------------------------------------------------------

StopWatch::~StopWatch(void)
{
}

//-------------------------------------------------------------------------------------------------

void StopWatch::Restart()
{
#if defined(_MSC_VER) || defined(__BORLANDC__)
	unsigned __int64 tmp;

	QueryPerformanceFrequency((LARGE_INTEGER *) &tmp);
	m_Frequency = (uint64b)tmp;

	QueryPerformanceCounter((LARGE_INTEGER *) &tmp);
	m_StartTime = (uint64b)tmp;
#endif

#if defined(__POSIX__)
	timespec tmVal;
#if defined(__PIKEOS__)
	dd_get_time(&tmVal);
#elif defined(__OS_X__)
    struct timeval tv;
    gettimeofday(&tv, NULL);
    tmVal.tv_sec = tv.tv_sec + 0;
    tmVal.tv_nsec = 0;
#else
	// fixme: co kdyz to nefunguje - poresit chybove stavy
	sint32b res = clock_gettime(CLOCK_REALTIME, &tmVal);

	if (res == 0)
#endif
	m_StartTime = GET_TICKS100NS(tmVal);
#endif

#if defined(__FREERTOS__)
	m_StartTime = ((GetUsecSinceStart() / 1000) * TimeRanges::TicksPerMilisecs);
#endif
}

//-------------------------------------------------------------------------------------------------

uint64b StopWatch::GetTotalTime() const
{
#if defined(_MSC_VER) || defined(__BORLANDC__)
	unsigned __int64 currentTicks;

	QueryPerformanceCounter((LARGE_INTEGER *) &currentTicks);

	return (TimeRanges::TicksPerSeconds * (currentTicks - m_StartTime)) / m_Frequency;
#endif

#if defined(__POSIX__)
	timespec tmVal;
#if defined(__PIKEOS__)

	dd_get_time(&tmVal);
	//////////
	//uint64b ntime = dd_get_time_raw();	
	//return GET_TICKS100NS_RAW(ntime) - m_StartTime;
	//SharkPrintf("StopWatch::GetTotalTime tmVal.tv_nsec = %lu, ntime = %lu%lu\n", (unsigned long)tmVal.tv_nsec, (unsigned long)((uint64b)((uint64b)ntime >> (uint64b)32)) , (unsigned long)((uint64b)((uint64b)ntime & (uint64b)0xFFFFFFFF)));
	//////////
#elif defined(__OS_X__)
    struct timeval tv;
    gettimeofday(&tv, NULL);
    tmVal.tv_sec = tv.tv_sec + 0;
    tmVal.tv_nsec = 0;
#else
	// fixme: errors
	sint32b res = clock_gettime(CLOCK_REALTIME, &tmVal);
#endif
	return GET_TICKS100NS(tmVal) - m_StartTime;
#endif

#if defined(__FREERTOS__)
	return ((GetUsecSinceStart() / 1000) * TimeRanges::TicksPerMilisecs) - m_StartTime;
#endif

}

//-------------------------------------------------------------------------------------------------

uint64b StopWatch::GetTotalTimeInMs() const
{
	return (GetTotalTime() / TimeRanges::TicksPerMilisecs);
}

//-------------------------------------------------------------------------------------------------

