#ifndef __StopWatch_h
#define __StopWatch_h

#include "./datatypes.h"
#include "./TimeRanges.h"

/*!
 * \brief Stop watch class
 * \details Class for representing timers
 * \todo Internal - Odkomentovat
 */
class StopWatch
{
private:
#if defined(_MSC_VER) || defined(__BORLANDC__)
	uint64b m_Frequency;
#endif

    /*!
     * \brief Start time
     * \details Initialized timer - Starting time
     */
	uint64b m_StartTime;

public:
    /*!
     * \brief Constructor
     * \details Initialize object
     */
	StopWatch(void);
    /*!
     * \brief Constructor
     * \details Deinitialize object
     */
    ~StopWatch(void);

    /*!
     * \brief Restart
     * \details Restart ticker
     */
	void Restart(void);
	// Vraci pocet 100ns ticku
    /*!
     * \brief Get total time
     * \details Get current 100ns ticks
     * \return Current 100ns ticks
     */
	uint64b GetTotalTime(void) const;
    /*!
     * \brief Get total time in ms
     * \details Get current ms ticks
     * \return Current ticks in ms
     */
    uint64b GetTotalTimeInMs(void) const;
};

#endif

