#ifndef __SystemLogger_h
#define __SystemLogger_h

#if defined(__cplusplus) && (!defined(SYSLOG_USE_EXTERNAL_LOGGER))

#include <stdarg.h>
/*!
 * \brief System logger
 * \details Empty class for log messages
 */
class SystemLogger
{
	public:
        /*!
         * \brief Debug
         * \param[in] facility Formated message
         * \param[in] fmt Parameters for \c facility
         * \details Write Debug message
         */
		void LogDebug(const char *facility, const char *fmt, ...) { }
        /*!
         * \brief Info
         * \param[in] facility Formated message
         * \param[in] fmt Parameters for \c facility
         * \details Write Info message
         */
        void LogInfo(const char *facility, const char *fmt, ...) { }
        /*!
         * \brief Warning
         * \param[in] facility Formated message
         * \param[in] fmt Parameters for \c facility
         * \details Write Warning message
         */
        void LogWarning(const char *facility, const char *fmt, ...) { }
        /*!
         * \brief Error
         * \param[in] facility Formated message
         * \param[in] fmt Parameters for \c facility
         * \details Write Error message
         */
        void LogError(const char *facility, const char *fmt, ...) { }
};

extern SystemLogger Logger;
#else
#include "SystemLoggerExt.h"
#endif

#endif
