#ifndef __TimeRanges_h
#define __TimeRanges_h

#include "./datatypes.h"

typedef sint64b TimeSpan_t;
/*!
 * \brief Time ranges definitions
 * \details Static class for time ranges definitions
 * \todo SERVER!!!! - Odkomentovat
 */
class TimeRanges
{
	public:
        /*!
         * \brief Ticks per day
         * \details Ticks per day (864000000000LL)
         */
        static const sint64b TicksPerDay;
        /*!
         * \brief Ticks per hour
         * \details Ticks per hour (36000000000LL)
         */
        static const sint64b TicksPerHour;
        /*!
         * \brief Ticks per minute
         * \details Ticks per minute (600000000LL)
         */
        static const sint64b TicksPerMinute;
        /*!
         * \brief Ticks per seconds
         * \details Ticks per seconds (10000000LL)
         */
        static const sint64b TicksPerSeconds;
        /*!
         * \brief Ticks per miliseconds (10000LL)
         * \details Ticks per miliseconds
         */
        static const sint64b TicksPerMilisecs;
        /*!
         * \brief Ticks per mikroseconds (10LL)
         * \details Ticks per mikroseconds
         */
        static const sint64b TicksPerMikrosecs;
};

#endif
