/*!
 * \file datatypes.h
 * Define used types and definitions
 */

#ifndef __datatypes_h__324875943252930465293045__
#define __datatypes_h__324875943252930465293045__

#if !defined(STANDALONE_SUPPORT)
//#include "./platform.h"
#include <cstddef>
#endif

/**
 *  
 */
typedef unsigned char uint8b;
typedef signed char   sint8b;

typedef unsigned short int uint16b;
typedef signed short int   sint16b;

typedef unsigned int uint32b;
typedef signed int   sint32b;

typedef unsigned long long int uint64b;
typedef signed long long int   sint64b;

typedef char char8b;


#define SINT32B_MAX ((sint32b)0x7fffffff)
#define SINT32B_MIN ((sint32b)0x80000000)


/*!
 * \brief Portable data type for characters. Since UNICODE characters are encoded differently under different platforms
 * (Win - UCS2/UTF-16, Linux UCS4), wchar_t is not used.
 */
typedef unsigned short int char16b;

typedef float float32b;
typedef double float64b;

//#if defined(PIKEOS_SUPPORT)
#if defined(__cplusplus)
extern "C" {
#endif

#define            VMRealloc(Blk,NewSize)  VMReallocImpl  ( (void**) (void*) Blk, NewSize )


void             * VMMalloc                                ( sint32b           Size );
uint32b VMGetHeapSize(void);
uint32b VMGetHeapFree(void);
void               VMFree                                  ( void            * Blk );
#if !defined(STANDALONE_SUPPORT)
bool               VMReallocImpl                           ( void           ** Blk,
                                                             sint32b           NewSize );
#endif

uint16b            ToHiLo16                                ( uint16b           X );
uint32b            ToHiLo32                                ( uint32b           X );
uint64b            ToHiLo64                                ( uint64b           X );
float32b           ToHiLoF32                               ( float32b          X );
float64b           ToHiLoF64                               ( float64b          X );

#define            ToHost16      ToHiLo16
#define            ToHost32      ToHiLo32
#define            ToHost64      ToHiLo64

#define            ToNet16       ToHiLo16
#define            ToNetF32      ToHiLoF32
#define            ToNetF64      ToHiLoF64

#if !defined(STANDALONE_SUPPORT)
bool               PlatformIsBigEndian                     ( void );
#endif
#if defined(__cplusplus)
}
#endif

#if !defined(STANDALONE_SUPPORT)
void * operator new       ( size_t Size );
void * operator new []    ( size_t Size );
void   operator delete    ( void * Data );
void   operator delete [] ( void * Data );
void * operator new       ( size_t Size, void * Dummy );
void   operator delete    ( void * Data, void * Dummy );
#endif

#define SharkMin(x,y) ((x) < (y) ? (x):(y))
#define SharkMax(x,y) ((x) > (y) ? (x):(y))

#endif /* __datatypes_h__324875943252930465293045__ */

